/**
 * ϥåطΥƥȥץ
 * $Source: /cvs/si/test/gradetest.c,v $
 * $Id: gradetest.c,v 1.4 2002/04/30 18:17:54 mik Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "../getopt.h"
#include "../si.h"
#include "../ui.h"

void usage( void ) {
  fprintf( stderr, "SI SHOGI\n" );
  fprintf( stderr, "usage : si [-d num]\n" );
  fprintf( stderr, "        -d num    Debug lebel. Default is 0, max 5.\n" );
  fprintf( stderr, "        -n        Change display mode.\n" );
  fprintf( stderr, "        -h -v     Print help. This output.\n" );

  exit( 0 );
}

int main(int argc, char *argv[]) {
  BOARD *bo = newBOARDwithInit();
  int c;
  extern char *optarg;
  extern int optind;
  extern int DEBUG_LEVEL;
  extern int flgDisplayMode;
  static TE te;
  int prevkey;
  extern const unsigned long HASH_MAX;
  int p;
  extern si_int64 hashval[16][16 * 11];
  HASH hs;
  
  while ( (c=si_getopt( argc, argv, "hnv")) != -1 ) {
    switch ( c ) {
    case 'n':
      flgDisplayMode = 1;
      break;
    case 'h':
    case 'v':
    default:
      usage();
      break;
    }
  }

  argc -= optind;
  argv += optind;
 
  if ( argv[ 0 ] == '\0' ) {
    if ( loadBOARD( "gradetest.brd", bo ) ) {
      fprintf( stderr, "File not found.\n" );
      exit( 0 );
    }
  } else {
    if ( loadBOARD( argv[ 0 ], bo ) ) {
      fprintf( stderr, "File not found.\n" );
      exit( 0 );
    }
  }
  
  boPlayInit( bo );

  putBOARD(bo);

  /* boMove(), boBack() Ǥɾͤιƥ */
  bo->point[ SENTE ] = grade(bo, 0);
  bo->point[ GOTE ] = grade(bo, 1);
  printf("sente grade : %d\n", bo->point[ SENTE ]);
  printf("gote  grade : %d\n", bo->point[ GOTE ]);
  
  te.fm = 0x88;
  te.to = 0x22;
  te.nari = 1;
  te.uti = 0;
  
  boMove( bo, &te, 0 );

  putBOARD(bo);
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);

  te.fm = 0x13;
  te.to = 0x22;
  te.nari = 0;
  te.uti = 0;
  
  boMove( bo, &te, 1 );
  
  putBOARD(bo);
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);

  boBack( bo, 1 );

  putBOARD(bo);
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);

  boBack( bo, 0 );
  
  putBOARD(bo);
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);
  /* ----- boMove(), boBack() Ǥɾͤιƥ */

  /* ----- oh_safe_grade Υƥ */
  /*
  printf("----- oh_safe_grade Υƥ\n");
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);
  te.fm = 0x17;
  te.to = 0x39;
  te.nari = 0;
  te.uti = 0;
  boMove( bo, &te, 0 );
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);
  boBack( bo, 0 );
  printf("sente grade : %d\n", bo->point[ 0 ]);
  printf("gote  grade : %d\n", bo->point[ 1 ]);
   */
  /* ----- oh_safe_grade Υƥ */
  
  return 0;
}
