/**
 * ϥåطΥƥȥץ
 * $Source: /cvs/si/test/hash_test.c,v $
 * $Id: hash_test.c,v 1.5 2002/05/01 08:17:51 mik Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "../getopt.h"
#include "../si.h"
#include "../ui.h"

void usage( void ) {
  fprintf( stderr, "SI SHOGI\n" );
  fprintf( stderr, "usage : si [-d num]\n" );
  fprintf( stderr, "        -d num    Debug lebel. Default is 0, max 5.\n" );
  fprintf( stderr, "        -n        Change display mode.\n" );
  fprintf( stderr, "        -h -v     Print help. This output.\n" );

  exit( 0 );
}

int main(int argc, char *argv[]) {
  BOARD *bo = newBOARDwithInit();
  int c;
  extern char *optarg;
  extern int optind;
  extern int DEBUG_LEVEL;
  extern int flgDisplayMode;
  static TE te;
  int prevkey;
  extern const unsigned long HASH_MAX;
  int p;
  extern si_int64 hashval[16][16 * 11];
  HASH hs;
  
  while ( (c=si_getopt( argc, argv, "hnv")) != -1 ) {
    switch ( c ) {
    case 'n':
      flgDisplayMode = 1;
      break;
    case 'h':
    case 'v':
    default:
      usage();
      break;
    }
  }

  argc -= optind;
  argv += optind;
 
  if ( argv[ 0 ] == '\0' ) {
    if ( loadBOARD( "test.brd", bo ) ) {
      fprintf( stderr, "File not found.\n" );
      exit( 0 );
    }
  } else {
    if ( loadBOARD( argv[ 0 ], bo ) ) {
      fprintf( stderr, "File not found.\n" );
      exit( 0 );
    }
  }
  
  boPlayInit( bo );

  putBOARD(bo);

#ifdef USE_HASH
  printf("start newHASH()\n");
  newHASH();
  printf("end newHASH()\n");
#endif

  /* boMove_mate()boBack_mate() Ǥ key ιƥ */
  putBOARD(bo);
  printf("%lx\n", bo->key);
  prevkey = bo->key;
  te.fm = 0x43;
  te.to = 0x33;
  te.nari = 0;
  te.uti = 0;
  boMove_mate( bo, &te, bo->next );
  printf("%lx\n", bo->key);
  boBack_mate( bo, bo->next );
  printf("%lx\n", bo->key);
  assert( prevkey == bo->key );
  /* --------------------------------------------------- */

  /* boMove()boBack() Ǥ key ιƥ */
  putBOARD(bo);
  printf("%lx\n", bo->key);
  prevkey = bo->key;
  te.fm = 0x43;
  te.to = 0x33;
  te.nari = 0;
  te.uti = 0;
  boMove( bo, &te, bo->next );
  printf("%lx\n", bo->key);
  boBack( bo, bo->next );
  printf("%lx\n", bo->key);
  assert( prevkey == bo->key );
  /* --------------------------------------------------- */

  /* hsPutBOARD() ̤ϥåϿƥȡ */
  hsPutBOARD(bo, CHECK_MATE, 0, 0);
  /* ͤФ */
  assert( hsGetBOARD(bo, &p, 0, 0) );
  assert( p == CHECK_MATE );
  /* --------------------------------------------------- */
  
  /* hsPutBOARD() ̤ϥåϿƥȡ */
  hsPutBOARD(bo, CHECK_MATE, 0, 0);
  te.fm = 0x43;
  te.to = 0x33;
  te.nari = 1;
  te.uti = 0;
  boMove( bo, &te, bo->next );
  /* ͤФ */
  assert( hsGetBOARD(bo, &p, 0, 0) == 0 );
  /* --------------------------------------------------- */
  
#ifdef NOREAD
  /* hsPutBOARD()  keyͤβ¤ιƥȡ辰 */
  bo->key = 0;
  hsPutBOARD(bo, 0);
  /* --------------------------------------------------- */
  
  /* hsPutBOARD()  keyͤξ¤ιƥȡ辰 */
  bo->key = HASH_MAX;
  hsPutBOARD(bo, 0);
  /* --------------------------------------------------- */
  
  /* hsGetBOARD()  keyͤξ¤ιƥȡ辰 */
  bo->key = HASH_MAX;
  hsGetBOARD(bo, &p);
  /* --------------------------------------------------- */
  
  /* hsGetBOARD()  keyͤβ¤ιƥȡ辰 */
  bo->key = 0;
  hsGetBOARD(bo, &p);
  /* --------------------------------------------------- */
  
  bo->board[ 0x35 ] = 0;
  bo->board[ 0x45 ] = FU + 0x10;
  
  /* hsGetBOARD()  keyͤξ¤ιƥȡ顼 */
  bo->key = HASH_MAX;
  hsGetBOARD(bo, &p);
  /* --------------------------------------------------- */
  
  /* hsGetBOARD()  keyͤβ¤ιƥȡ顼 */
  bo->key = 0;
  hsGetBOARD(bo, &p);
  /* --------------------------------------------------- */
#endif /* NOREAD*/

#ifdef NOREAD
  /* hsSetPiece(), hsSuperiorBOARD() Υƥ */
  hsSetPiece( &hs, bo );
  printf("hs.piece[ 0 ] : %x\n", hs.piece[ 0 ] );
  printf("hs.piece[ 1 ] : %x\n", hs.piece[ 1 ] );
  printf("hsSuperiorBOARD( &hs, bo ) : %d\n", hsSuperiorBOARD( &hs, bo ) );
  bo->piece[ SENTE ][ FU ] = 0;
  printf("hsSuperiorBOARD( &hs, bo ) : %d\n", hsSuperiorBOARD( &hs, bo ) );
  bo->piece[ SENTE ][ FU ] = 1;
  bo->piece[ SENTE ][ HISYA ] = 2;
  bo->piece[ GOTE ][ HISYA ] = 2;
  printf("hsSuperiorBOARD( &hs, bo ) : %d\n", hsSuperiorBOARD( &hs, bo ) );
  /* --------------------------------------------------- */
#endif /* NOREAD */
  
#ifdef USE_HASH
  freeHASH();
#endif /* USE_HASH */

  return 0;
}
